add content

This commit is contained in:
2019-05-08 14:53:59 +03:00
parent fdb66ec988
commit 840f37da49
122 changed files with 5873 additions and 0 deletions

7
sys-libs/musl/Manifest Normal file
View File

@@ -0,0 +1,7 @@
AUX ldconfig.in 2552 BLAKE2B c94f9900e8582d707519171c4b61079c801b60c555677b1740b04adbdec9645578b9a8fc91f11413072568f316c795e46a332970f3d2dde5272b0c49a5d60a78 SHA512 59f1b57361196363d3f127366764f05d26c23dbe3d3dbcdba9bd3c8ca26a671fd713b96d31c509d22805c57ada2b596d979a3f5795bcf0a4d3ac7d168f3bf377
DIST getconf.c 11614 BLAKE2B ba49a573fc16d51780a0b0b81fbf7b64a1142f1dbad203c9609a59b6b07e7404f676c415383ae88c0aede95694821f6ee381bffd93cc3330501e17dc07d122bd SHA512 0d80f37b34a35e3d14b012257c50862dfeb9d2c81139ea2dfa101d981d093b009b9fa450ba27a708ac59377a48626971dfc58e20a3799084a65777a0c32cbc7d
DIST getent.c 9438 BLAKE2B dc20353583c10a001bd8fe8474f32b70254dc56da186d1cdbaf4081570c3d7a10497024da5815a485fc4728adc9eebd270aec99ba93b7546b38c728978e3e00b SHA512 b35de9847353b273516162ed4828a810c6130fc5b7de44ee4433003b3f99647b25792d9b1c40dfc67069add11f3fb850e5c35d4f1912dccac108059bbbdfd5a2
DIST iconv.c 2577 BLAKE2B 070ca87b30c90ab98c27d5faf7a2fcb64ff7c67ca212ee6072165b2146979c551f714954dbd465462a171837c59b6ea027e0206458a2df0f977e45f01be3ce48 SHA512 9d42d66fb1facce2b85dad919be5be819ee290bd26ca2db00982b2f8e055a0196290a008711cbe2b18ec9eee8d2270e3b3a4692c5a1b807013baa5c2b70a2bbf
DIST musl-1.1.19.tar.gz 960319 BLAKE2B 3e69de2ed9384fe200bb64e603f342a930acf035cf7bac8fe3cd4225800424207df2b73fe6fabf3147fc8023a655839c33f50c0be8e30f51f76b84aba4de30b5 SHA512 abee52d53af4b3c14c9088866c911a24d2b6ef67dc494f38a7a09dfe77250026f77528c24c52469c89cffa8ced2f0fa95badbdcf8d4460c90faba47e3927bcc5
EBUILD musl-1.1.19.ebuild 3046 BLAKE2B dd3ec79934c99b2bbe10d34d6efabe818fc1e94320fd44779a1ad6394e16bac0ac077742cab1c7ceaf554ab74d9825386d63cae95814ec564e5f92636fb52fcf SHA512 6bc48fad1aea48f7cc153cb82ee0cb1b08bc396f66ef6731fcf5e668e58a4154d2f404ed197b6be6c26449f71bd3479c0f52ccb51984ff9af45d04cbf4c47f1c
MISC metadata.xml 452 BLAKE2B f6d26f456e1a1005b0103c6921d59504dcacddfaf9ec3c788f6f626df670ec7e979a8a66626d7de24d0b850651bf095610c191d520b67915a701bf8564189fc4 SHA512 676d8122179a5cb56e0b9c7aeb7f0aec8c19b5d7b604a19c9ee01aeca837a74cc4284e87cc743d0eaf527f0c79afdfeb1f238c204a8a6c1c5590b2718bbc9b03

View File

@@ -0,0 +1,144 @@
#!/bin/bash -e
# Copyright 1999-2015 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
ROOT="/"
LDSO_CONF="/etc/ld.so.conf"
if [[ ! -e $LDSO_CONF ]]; then
echo "$LDSO_CONF not found" >&2
exit 1
fi
LDSO_CONF_DIR=$(dirname $LDSO_CONF)
VERBOSE=0
UPDATE_LINKS=1
get_options() {
while getopts "vnNXf:C:r:p" opt "$@"; do
case $opt in
v)
echo "ldconfig for musl in Gentoo"
VERBOSE=1
;;
r)
ROOT=$OPTARG
;;
f)
LDSO_CONF=$OPTARG
;;
X)
UPDATE_LINKS=0
;;
\?)
echo "Invalid option: -$opt" >&2
exit 1
;;
n|N|C|p)
echo "Unimplemented option: -$opt" >&2
exit 1
;;
esac
done
if [[ $UPDATE_LINKS == 1 ]]; then
echo "Updating links is not implemented."
fi
}
repeated() {
local l=$1
local drs="${@:2}"
for m in $drs; do
[[ $m == $l ]] && return 0
done
return 1
}
expand() {
# We are assuming the ld.so.conf's 'include' is not recursive
local f line l
local glob="$LDSO_CONF_DIR/$1"
local drs="${@:2} "
for f in $glob; do
[[ ! -f $f ]] && continue
while read line; do
line=${line%%#*}
line=${line//:/ }
line=${line//,/ }
for l in $line; do
#We must add this whether or not the directory exists
repeated $l $drs && continue
drs+=" $l "
done
done < $f
done
echo $drs
}
read_ldso_conf() {
local drs=" "
while read line; do
# Sanitize the line - see ldconfig(8) for delimiters
# Note: bash read turns tabs into spaces and read already
# delimits on newlines with the default $IFS
line=${line%%#*} # Remove comments
line=${line//:/ } # Change colon delimiter to space
line=${line//,/ } # Change comma delimiter to space
next=0
for l in $line; do
if [[ $next == 1 ]]; then
next=0
drs=$(expand $l $drs)
elif [[ $l == "include" ]]; then
next=1
else
# glibc's ldconfig silently skips non directories
if [[ -d $l ]]; then
repeated $l $drs && continue
drs+=" $l "
fi
fi
done
done < $1
echo $drs
}
sanitize() {
local drs=$@
repeated "/lib" $drs || drs="/lib $drs"
repeated "/usr/lib" $drs || drs="/usr/lib $drs"
echo $drs
}
get_options "$@"
drs=$(read_ldso_conf "$LDSO_CONF")
drs=$(sanitize $drs)
ARCH=@@ARCH@@
LDSO_PATH="/lib/ld-musl-${ARCH}.so.1"
if [[ ! -e $LDSO_PATH ]]; then
echo "$LDSO_PATH not found" >&2
exit 1
fi
LDSO_ARCH=$(basename $LDSO_PATH)
LDSO_NAME=${LDSO_ARCH%.so.1}
ETC_LDSO_PATH=/etc/${LDSO_NAME}.path
X=$(mktemp -p /tmp ${LDSO_NAME}.XXXXXX)
for d in $drs; do
echo $d >> $X
done
chmod 644 $X
mv $X $ETC_LDSO_PATH

View File

@@ -0,0 +1,15 @@
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
<pkgmetadata>
<maintainer type="person">
<email>blueness@gentoo.org</email>
<name>Anthony G. Basile</name>
</maintainer>
<maintainer type="person">
<email>lu_zero@gentoo.org</email>
</maintainer>
<maintainer type="project">
<email>toolchain@gentoo.org</email>
<name>Gentoo Toolchain Project</name>
</maintainer>
</pkgmetadata>

View File

@@ -0,0 +1,118 @@
# Copyright 1999-2018 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
EAPI=6
inherit eutils flag-o-matic multilib toolchain-funcs
if [[ ${PV} == "9999" ]] ; then
EGIT_REPO_URI="git://git.musl-libc.org/musl"
inherit git-r3
SRC_URI="
https://dev.gentoo.org/~blueness/musl-misc/getconf.c
https://dev.gentoo.org/~blueness/musl-misc/getent.c
https://dev.gentoo.org/~blueness/musl-misc/iconv.c"
KEYWORDS=""
else
SRC_URI="http://www.musl-libc.org/releases/${P}.tar.gz
https://dev.gentoo.org/~blueness/musl-misc/getconf.c
https://dev.gentoo.org/~blueness/musl-misc/getent.c
https://dev.gentoo.org/~blueness/musl-misc/iconv.c"
KEYWORDS="-* amd64 arm ~mips ppc x86"
fi
export CBUILD=${CBUILD:-${CHOST}}
export CTARGET=${CTARGET:-${CHOST}}
if [[ ${CTARGET} == ${CHOST} ]] ; then
if [[ ${CATEGORY} == cross-* ]] ; then
export CTARGET=${CATEGORY#cross-}
fi
fi
DESCRIPTION="Light, fast and simple C library focused on standards-conformance and safety"
HOMEPAGE="http://www.musl-libc.org/"
LICENSE="MIT LGPL-2 GPL-2"
SLOT="0"
IUSE="headers-only"
QA_SONAME="/usr/lib/libc.so"
QA_DT_NEEDED="/usr/lib/libc.so"
is_crosscompile() {
[[ ${CHOST} != ${CTARGET} ]]
}
just_headers() {
use headers-only && is_crosscompile
}
pkg_setup() {
if [ ${CTARGET} == ${CHOST} ] ; then
case ${CHOST} in
*-musl*) ;;
*) die "Use sys-devel/crossdev to build a musl toolchain" ;;
esac
fi
}
src_configure() {
tc-getCC ${CTARGET}
just_headers && export CC=true
local sysroot
is_crosscompile && sysroot=/usr/${CTARGET}
./configure \
--target=${CTARGET} \
--prefix=${sysroot}/usr \
--syslibdir=${sysroot}/lib \
--disable-gcc-wrapper || die
}
src_compile() {
emake obj/include/bits/alltypes.h
just_headers && return 0
emake
if [[ ${CATEGORY} != cross-* ]] ; then
$(tc-getCC) ${CFLAGS} "${DISTDIR}"/getconf.c -o "${T}"/getconf || die
$(tc-getCC) ${CFLAGS} "${DISTDIR}"/getent.c -o "${T}"/getent || die
$(tc-getCC) ${CFLAGS} "${DISTDIR}"/iconv.c -o "${T}"/iconv || die
fi
}
src_install() {
local target="install"
just_headers && target="install-headers"
emake DESTDIR="${D}" ${target}
just_headers && return 0
# musl provides ldd via a sym link to its ld.so
local sysroot
is_crosscompile && sysroot=/usr/${CTARGET}
local ldso=$(basename "${D}"${sysroot}/lib/ld-musl-*)
dosym ${sysroot}/lib/${ldso} ${sysroot}/usr/bin/ldd
if [[ ${CATEGORY} != cross-* ]] ; then
local arch=$("${D}"usr/lib/libc.so 2>&1 | sed -n '1s/^musl libc (\(.*\))$/\1/p')
[[ -e "${D}"/lib/ld-musl-${arch}.so.1 ]] || die
cp "${FILESDIR}"/ldconfig.in "${T}" || die
sed -e "s|@@ARCH@@|${arch}|" "${T}"/ldconfig.in > "${T}"/ldconfig || die
into /
dosbin "${T}"/ldconfig
into /usr
dobin "${T}"/getconf
dobin "${T}"/getent
dobin "${T}"/iconv
echo 'LDPATH="include ld.so.conf.d/*.conf"' > "${T}"/00musl || die
doenvd "${T}"/00musl || die
fi
}
pkg_postinst() {
is_crosscompile && return 0
[ "${ROOT}" != "/" ] && return 0
ldconfig || die
# reload init ...
/sbin/telinit U 2>/dev/null
}